#!/usr/bin/perl
# ==================================================================
# File manager - enhanced web based file management system
#
#   Website  : http://gossamer-threads.com/
#   Support  : http://gossamer-threads.com/scripts/support/
#   Revision : $Id$
# 
# Copyright (c) 2001 Gossamer Threads Inc.  All Rights Reserved.
# Redistribution in part or in whole strictly prohibited. Please
# see LICENSE file for full details.
# ==================================================================

    use lib '/usr/local/interworx/lib/fileman/lib';
    use strict;
    use GT::Base qw/:all/;
    use GT::CGI;
    use GT::FileMan;
    $| = 1;
    local $SIG{__DIE__}   = \&GT::FileMan::fatal;
    
    main();

sub main () {
#-------------------------------------------------------------------
    my $uid = $<;

# Make sure it's a valid userid.
    my ($user,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire) = getpwuid($uid);
    if (! defined $user) {
        die sprintf ($GT::FileMan::Commands::LANGUAGE{COBALT_NOUSER}, $uid);
    }
# Can't run as uid < 500.
    if ($uid < 500) {
        die sprintf ($GT::FileMan::Commands::LANGUAGE{COBALT_BADUID}, $user, $uid);
    }
# Set root dir
    my ($root_dir) = $ARGV[0];
    if (! $root_dir or ! -d $root_dir) {
        die sprintf ($GT::FileMan::Commands::LANGUAGE{COBALT_BADDIR}, $dir);
    }

# Turn off template cache as it can't be used due to permissions.
    local $GT::Template::ATTRIBS->{dont_save} = 1;

# Set our tmp directory.
    $ENV{GT_TMPDIR} = '/tmp';

# Create our FileMan object, you can enable disable commands here.
    my $fm = GT::FileMan->new ( 
                    cfg => {
                                template_root    => '/usr/local/interworx/lib/fileman/templates',
                                html_root_url    => '/siteworx/images/fileman',
                                root_dir         => $root_dir,
                                root_url         => '/',
                                passwd_dir_level => 0,
				http_ref => '/siteworx/cgi-bin/fileman'
                    },
                    commands      => {
                                    cmd_search      => 1,
                                    cmd_replace     => 1,
                                    cmd_command     => 0,
                                    cmd_upload      => 1,
                                    cmd_editor      => 1,
                                    cmd_passwd      => 1,
                                    cmd_makedir     => 1,
                                    cmd_preferences => 1,
                                    cmd_edit        => 1,
                                    cmd_download    => 1,
                                    cmd_copy        => 1,
                                    cmd_delete      => 1,
                                    cmd_move        => 1,
                                    cmd_chmod       => 1,
                                    cmd_tail        => 1,
                                    cmd_perl        => 0,
                                    cmd_diff        => 1,
                                    cmd_tar         => 1,    
				    cmd_print       => 1,
                    }
    );

# Now run the script
    $fm->process();

}
