
<!---------------------------------------------------------
  NodeWorx Template
  -------------------------------------------------------->

<!---------------------------------------------------------
  This template is used to display your server overview,
  including your info, the server info, and a quick look at
  the server statistics.
  -------------------------------------------------------->

<!---------------------------------------------------------
  PLEASE read the skinning  manual before editing this
  template.  The skinning manual can be found at:
  http://interworx.info/products/iworx-cp/themes/howto/
  -------------------------------------------------------->

<!---------------------------------------------------------
  Smarty variables available to the template designer:

  Just edit the iworx.ini file to see a popup window of
  what smarty variables are available to you.  You should
  base all of your templates on the iw_ prefix'd variables
  as any others *may* change
  -------------------------------------------------------->

{if $iw_zone.istemplate}
  {assign var=domain value=##LG_DNS_TEMPLATE##}
  {assign var=host_domain value=$iw_zone.tdomain}
{else}
  {assign var=domain value=$iw_zone.domain}
  {assign var=host_domain value=$iw_zone.domain}
{/if}

{include file="content-frame-top.tpl"
         header="##LG_DNSRECORDMANAGEMENT## :: $domain"}

{literal}
<script language="javascript">
  function updateRow( mode ) {
    document[mode].target.disabled = false;
    document[mode].host.disabled   = false;

    document[mode].host.value = "{/literal}{$host_domain}{literal}";
    document[mode].target.value = '';

    switch( document[mode].type.value ) {
      case "SOA":
        document[mode].target.value    = '';
        document[mode].target.disabled = true;
        break;

      case "MX":
        document[mode].host.value   = "<< mail.domain.com >>";
        document[mode].target.value = 10;
        break;

      case "NS":
        document[mode].host.disabled = true;
        document[mode].target.value = "<< ns1.domain.com >>";
        break;

      case "A":
        document[mode].target.value = "<< ##LG_IPADDRESS## >>";
        break;

      case "TXT":
        document[mode].target.value  = "<< ##LG_STRING## >>";
        break;

      case "CNAME":
        document[mode].host.value   = "<< ##LG_ALIAS## >>";
        document[mode].target.value = "<< ##LG_CANONICALNAME## >>";
        break;

      case "PTR":
        document[mode].host.value   = '.in-addr.arpa';
        hostname = new String( "<< ##LG_HOSTNAME## >>" );
        document[mode].target.value = hostname.toLowerCase();
        break;

    }
  }
</script>
{/literal}

  {* for tabindex *}
  {counter start=1 print=false}

  {cycle values="row1,row2" print=false advance=false}

  {if $iw_zone.istemplate}
    <div class="service_neutral_box">
      ##LG_DNS_EDITING_TEMPLATE##
    </div>
    <br>
  {/if}

  {if $iw_zone.isattached}
    <div class="service_neutral_box">
      ##LG_DNS_EDITING_ATTACHED_ZONE##
    </div>
    <br>
  {/if}

  <table id="datatable"
         width="100%">

    <!-- RECORD LISTING -->

    <tr id="datatable_header">
      <td colspan="2">
        ##LG_ACTION##:
      </td>
      <td class="left">
        ##LG_HOST##:
        [<a href="javascript:quickhelp('LG_QH_DNSHOST');">?</a>]
      </td>
      <td width="5%" nowrap>
        ##LG_TYPE##:
        [<a href="javascript:quickhelp('LG_QH_DNSRECORDTYPE');">?</a>]
      </td>
      <td class="left">
        ##LG_TARGET##:
        [<a href="javascript:quickhelp('LG_QH_DNSTARGET');">?</a>]
      </td>
      <td width="5%" nowrap>
        ##LG_TTL##:
        [<a href="javascript:quickhelp('LG_QH_DNSTTL');">?</a>]
      </td>
    </tr>

    {foreach item=record from=$iw_zone.records}

      {if $record.record_id eq $iw_edit_record.record_id}

      <form action="{$iw_self}?mode=record&action=edit&do=commit&zone_id={$iw_zone.zone_id}&record_id={$record.record_id}" method="post" name="edit">
      <tr class="{cycle}">
        <td width="2%">
          <input type="button"
                 class="button"
                 value="##LG_CANCEL##"
                 onClick='window.location = "{$iw_self}?mode=record&zone_id={$iw_zone.zone_id}";'>
        </td>
        <td width="2%">
          <input type="submit"
                 class="button"
                 value="##LG_SAVE##">
        </td>
        <td>
          <input type="text"
                 class="textbox"
                 size="32"
                 maxlength="255"
                 name="input[host]"
                 id="host"
                 {if $iw_edit_record.type eq 'NS'}disabled{/if}
                 value="{$iw_edit_record.host|default:$host_domain}">
        </td>
        <td class="center">
          <select onChange="updateRow('edit');"
                  class="select"
                  name="input[type]"
                  id="type">
            {foreach key=name item=code from=$iw_types}
              {if $name neq 'SOA'}
                <option value="{$name|upper}" {if $name eq $iw_edit_record.type}selected{/if}>{$name|upper}</option>
              {/if}
            {/foreach}
          </select>
        </td>
        <td>
          <input type="text"
                 class="textbox"
                 name="input[target]"
                 id="target"
                 size="32"
                 maxlength="255"
                 value="{$iw_edit_record.target}">
        </td>
        <td class="center">
          <input type="text"
                 class="textbox"
                 name="input[ttl]"
                 id="ttl"
                 size="7"
                 value="{$iw_edit_record.ttl}">
        </td>
      </tr>

      </form>

      {else}

      <tr class="{cycle} ruler">
        {if $record.type neq 'SOA'}

        <td nowrap>
          [ <a href="{$iw_self}?mode=record&action=delete&zone_id={$record.zone_id}&record_id={$record.record_id}">##LG_DELETE##</a> ]
        </td>

        <td nowrap>
          [ <a href="{$iw_self}?mode=record&action=edit&zone_id={$record.zone_id}&record_id={$record.record_id}">##LG_EDIT##</a> ]
        </td>
        </form>

        {else}

        <td width="2%" nowrap>
          [ ##LG_DELETE## ]
        </td>
        <td width="2%" nowrap>
          [ ##LG_EDIT## ]
        </td>

        {/if}

        <td>
          {$record.host|default:$host_domain}
        </td>
        <td class="center">
          {$record.type|upper}
        </td>
        <td>
          {if $record.type eq 'SOA'}
            <a href="{$iw_self}?mode=zone&action=edit&zone_id={$record.zone_id}">##LG_EDITSOAPROPERTIESFORTHISZONE##</a>
          {else}
            {$record.target}
          {/if}
        </td>
        <td class="center">
          {$record.ttl}
        </td>
      </tr>

      {/if}

    {/foreach}

    {if count( $iw_records ) gt 0 && $iw_edit_record eq ''}
    <tr><td colspan="6"><hr size="0"></td></tr>
    {/if}

    {if $iw_edit_record eq ''}
      <form action="{$iw_self}?mode=record&action=add&zone_id={$iw_zone.zone_id}" 
            method="post" 
            name="add">
      <tr id="datatable_footer">
        <td colspan="2" class="center">
          <input type="submit"
                 class="button"
                 value="##LG_ADD##">&nbsp;
          [<a href="javascript:quickhelp('LG_QH_DNSRECORDADD');">?</a>]
        </td>
        <td>
          <input type="text"
                 class="textbox"
                 id="host"
                 maxlength="255"
                 size="32"
                 name="input[host]"
                 value="{$host_domain}">
        </td>
        <td class="center">
          <select onChange="updateRow('add');"
                  class="select"
                  id="type"
                  name="input[type]">
            {foreach key=name item=code from=$iw_types}
              {if $name neq 'SOA'}
              <option value="{$name|upper}" 
                      {if $name eq 'A'}
                        selected
                      {/if}>
                {$name|upper}
              </option>
              {/if}
            {/foreach}
          </select>
        </td>
        <td>
          <input type="text"
                 class="textbox"
                 name="input[target]"
                 maxlength="255"
                 size="32"
                 id="target"
                 value="&lt;&lt; ##LG_IPADDRESS## &gt;&gt;">
        </td>
        <td class="center">
          <input type="text"
                 class="textbox"
                 name="input[ttl]"
                 id="ttl"
                 size="7"
                 value="{$iw_ttl}">
        </td>
      </tr>

      </form>
    {/if}

    <!-- END RECORD LISTING -->

  </table>

{include file="content-frame-bottom.tpl"}
